/* time history accumulator; calculates and stores all history values, and
   performs combing on history values when low on memory */

#include "em1.h"

History()
{
  int i, isp, k;
  static int count=1;
  
  if (--count) return;			/* only accum every interval steps */
  if (hist_hi >= MAXHIST)		/* comb time histories */
    {
      for (isp=0; isp<nsp; isp++)
	{
	  for (i=1, k=4; i<MAXHIST/4; i++, k+=4)
	    {
	      px_hst[isp][i] = px_hst[isp][k];
	      py_hst[isp][i] = py_hst[isp][k];
	      pz_hst[isp][i] = pz_hst[isp][k];
	    }
	}
      for (i=1, k=4; i<MAXHIST/4; i++, k+=4)
	{
	  t_array[i] =	t_array[k];
	  bye_hst[i] =	bye_hst[k];
	  bze_hst[i] =	bze_hst[k];
	  exe_hst[i] =	exe_hst[k];
	  eye_hst[i] =	eye_hst[k];
	  eze_hst[i] =	eze_hst[k];
	  eyle_hst[i] = eyle_hst[k];
	  eyre_hst[i] = eyre_hst[k];
	  ezle_hst[i] = ezle_hst[k];
	  ezre_hst[i] = ezre_hst[k];
	}
      hist_hi = i;
      interval *= 4;	
    }
  for (isp=0; isp<nsp; isp++) 		/* accumulate histories */
    {
      px_hst[isp][hist_hi]	= px[isp];
      py_hst[isp][hist_hi]	= py[isp];
      pz_hst[isp][hist_hi]	= pz[isp];
    }
  bye_hst[hist_hi]	= bye;
  bze_hst[hist_hi]	= bze;
  exe_hst[hist_hi]	= exe;
  eye_hst[hist_hi]	= eye;
  eze_hst[hist_hi]	= eze;
  eyle_hst[hist_hi]	= eyle;
  eyre_hst[hist_hi]	= eyre;
  ezle_hst[hist_hi]	= ezle;
  ezre_hst[hist_hi]	= ezre;
  t_array[hist_hi] = t;
  hist_hi++; 
  count = interval;
}

/***************************************************************/











































































