#include "em1.h"

/****************************************************************/

InitWindows()
{
  int i;
  /*********************************************/
  /* Set up each window structure 	       */

  XGSet2D("linlin", "Position", "Vx-X Phase Space", "open", 300, 10, dx, 1.0,
	  False, False, 0.0, length, -1.0, 1.0);

  for (i=nsp-1; i>=0; i--) XGScat2D(pos[i], vx[i], &np[i], i);

  /*********************************************/

  XGSet2D("linlin", "Position", "Vy-X Phase Space", "open", 500, 10, dx, 1.0,
	  False, False, 0.0, length, -1.0, 1.0);

  for (i=nsp-1; i>=0; i--) XGScat2D(pos[i], vy[i], &np[i], i);

  /*********************************************/

  XGSet2D("linlin", "Position", "Vz-X Phase Space", "open", 300, 210, dx, 1.0,
	  False, False, 0.0, length, -1.0, 1.0);

  for (i=nsp-1; i>=0; i--) XGScat2D(pos[i], vz[i], &np[i], i);

  /*********************************************/

  XGSet2D("linlin", "Position", "x-Electric Field", "iconic", 400, 100, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, ex, &ng, 2);

  /*********************************************/

  XGSet2D("linlin", "Position", "y-Electric Field", "iconic", 300, 210, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, ey, &ng, 3);

  /*********************************************/

  XGSet2D("linlin", "Position", "z-Electric Field", "iconic", 100, 500, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, ez, &ng, 4);

  /*********************************************/

  XGSet2D("linlin", "Position", "x-Electric Potential", "iconic", 500, 500, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, phi, &ng, 5);

  /*********************************************/

  XGSet2D("linlin", "Position", "Smoothed Charge Density", "iconic", 300, 500, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, rho, &ng, 6);

  /*********************************************/

  XGSet2D("linlin", "Position", "Relativistic Electron Temp.", "iconic", 50, 1, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, thermx, &ng, 7);

  /*********************************************/

  XGSet2D("linlin", "Position", "y-Magnetic Field", "iconic", 600, 20, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, by, &ng, 0);

  /*********************************************/

  XGSet2D("linlin", "Position", "z-Magnetic Field", "iconic", 100, 300, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, bz, &ng, 1);

  /*********************************************/

  XGSet2D("linlin", "Position", "Left-Going y-Field", "iconic", 200, 200, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, eyl, &ng, 2);

  /*********************************************/

  XGSet2D("linlin", "Position", "Right-Going y-Field", "iconic", 100, 400, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, eyr, &ng, 3);

  /*********************************************/

  XGSet2D("linlin", "Position", "Left-Going z-Field", "iconic", 300, 300, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, ezl, &ng, 4);

  /*********************************************/

  XGSet2D("linlin", "Position", "Right-Going z-Field", "iconic", 400, 400, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, ezr, &ng, 5);

  /*********************************************/

  XGSet2D("linlin", "Position", "Right-Going Current (Jy+)", "iconic", 500, 500, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, jyp, &ng, 6);

  /*********************************************/

  XGSet2D("linlin", "Position", "Right-Going Current (Jz+)", "iconic", 600, 600, 1.0, 1.0,
	  False, True, 0.0, length);

  XGCurve(x_array, jzp, &ng, 7);

  /*********************************************/

  XGSet2D("linlin", "Time", "X-Momentum History", "iconic", 700, 10, 1.0, 1.0,
	  True, True);

  for (i=nsp-1; i>=0; i--) XGCurve(t_array, px_hst[i], &hist_hi, i);

  /**********************************************/

  XGSet2D("linlin", "Time", "Y-Momentum History", "iconic", 700, 200, 1.0, 1.0,
	  True, True);

  for (i=nsp-1; i>=0; i--) XGCurve(t_array, py_hst[i], &hist_hi, i);

  /**********************************************/

  XGSet2D("linlin", "Time", "Z-Momentum History", "iconic", 700, 400, 1.0, 1.0,
	  True, True);

  for (i=nsp-1; i>=0; i--) XGCurve(t_array, pz_hst[i], &hist_hi, i);

  /**********************************************/

  XGSet2D("linlin", "Time", "x E-field Energy History", "iconic", 500, 10, 1.0, 1.0,
	  True, True);

  XGCurve(t_array, exe_hst, &hist_hi, 0);

  /**********************************************/

  XGSet2D("linlin", "Time", "y E-field Energy History", "iconic", 500, 200, 1.0, 1.0,
	  True, True);

  XGCurve(t_array, eye_hst, &hist_hi, 1);

  /**********************************************/

  XGSet2D("linlin", "Time", "z E-field Energy History", "iconic", 500, 400, 1.0, 1.0,
	  True, True);

  XGCurve(t_array, eze_hst, &hist_hi, 2);

  /**********************************************/

  XGSet2D("linlin", "Time", "y B-field Energy History", "iconic", 300, 10, 1.0, 1.0,
	  True, True);

  XGCurve(t_array, bye_hst, &hist_hi, 3);

  /**********************************************/

  XGSet2D("linlin", "Time", "z B-field Energy History", "iconic", 300, 200, 1.0, 1.0,
	  True, True);

  XGCurve(t_array, bze_hst, &hist_hi, 4);

  /**********************************************/

  XGSet2D("linlin", "Time", "Left Field Energy Hist.(eyl)", "iconic", 300, 400, 1.0, 1.0,
	  True, True);

  XGCurve(t_array, eyle_hst, &hist_hi, 5);

  /**********************************************/

  XGSet2D("linlin", "Time", "Right Field Energy Hist.(eyr)", "iconic", 300, 600, 1.0, 1.0,
	  True, True);

  XGCurve(t_array, eyre_hst, &hist_hi, 6);

  /**********************************************/

  XGSet2D("linlin", "Time", "Left Field Energy Hist.(ezl)", "iconic", 100, 10, 1.0, 1.0,
	  True, True);

  XGCurve(t_array, ezle_hst, &hist_hi, 7);

  /**********************************************/

  XGSet2D("linlin", "Time", "Right Field Energy Hist.(ezr)", "iconic", 100, 200, 1.0, 1.0,
	  True, True);

  XGCurve(t_array, ezre_hst, &hist_hi, 0);

}

/****************************************************************/
char Revision[]={'1','.','0','0'};

void Dump(filename)
char *filename;
{
}

/****************************************************************/

void Restore(filename)
char *filename;
{
}

/****************************************************************/

Quit()
{

}

/****************************************************************/

